// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import static net.cellcomputing.himawari.library.EqModeBlock.*;

/**
 * 
 * Define the context that exists between calls to RiBegin/RiEnd.
 * RiBegin / RiEnd の呼び出している間に存在する、コンテキストを定義する。
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqMainModeBlock extends CqModeBlock
{
	
	/**
	 * コンストラクタ。　初期値の設定。
	 * @param	pconParent	前のcontext
	 */
	public CqMainModeBlock( final CqModeBlock pconParent )
	{
		// Create new Attributes as they must be pushed/popped by the state change.
		//　状態の変化で変わるアトリビュートを新しく作成。
		super( pconParent, BeginEnd );
		m_pattrCurrent = new CqAttributes();
		m_pattrCurrent.AddRef();
		m_ptransCurrent =  new CqTransform();
	}

	/**
	 *  デストラクタ。<br>
	 *	参照の削除。　(参照カウンタをデクリメント。) 
	 * @see net.cellcomputing.himawari.library.CqModeBlock#destruct()
	 */
	public void destruct()
	{
		m_pattrCurrent.Release();
	}


	/** 
	 * Create a main context.<br>
	 * メインのコンテキストを作成。
	 * 
	 * @warning このメソッドがメインのコンテキストから呼ばれた場合、エラーとなる。
	 */
	public CqModeBlock	BeginMainModeBlock()
	{
	   return ( null );
	}		

	/** 
	 * Delete the main context.<Br>
	 * 	メインのコンテキストを消去する。
	 * 
	 * @attention このメソッドのみ、メインのコンテキストを消去することができる。
	 */
	public void	EndMainModeBlock()
	{
		destruct();	
	}

	/** 
	 * Get a reference to the currently stored options.<br>
	 * 	現在保存されているオプションのゲッタ。
	 * 
	 * @return	m_optCurrent	現在のオプション
	 */
	public CqOptions optCurrent()
	{
		return ( m_optCurrent );
	}
	
	private CqOptions m_optCurrent = new CqOptions();	///< 現在のグラフィックス環境オプション。	Current graphics environment options.
}
